OpenGL-3.0.3.0: A binding for the OpenGL graphics system

Copyright | (c) Sven Panne 2002-2019
License | BSD3
Maintainer | Sven Panne <svenpanne@gmail.com>
Stability | stable
Portability | portable
Safe Haskell | None
Language | Haskell2010

Graphics.Rendering.OpenGL.GL.Texturing.Parameters

Description

This module corresponds to section 3.8.4 (Texture Parameters), section 3.8.7 (Texture Wrap Mode), section 3.8.8 (Texture Minification), and section 3.8.9 (Texture Magnification) of the OpenGL 2.1 specs.

Synopsis

- data TextureFilter
  - = Nearest
  - | Linear'
- type MinificationFilter = (TextureFilter, Maybe TextureFilter)
- type MagnificationFilter = TextureFilter
- textureFilter :: ParameterizedTextureTarget t => t -> StateVar (MinificationFilter, MagnificationFilter)
- data Repetition
  - = Repeated
  - | Mirrored
- data Clamping
  - = Clamp
  - | Repeat
  - | ClampToEdge
  - | ClampToBorder
- textureWrapMode :: ParameterizedTextureTarget t => t -> TextureCoordName -> StateVar (Repetition, Clamping)
- textureBorderColor :: ParameterizedTextureTarget t => t -> StateVar (Color4 GLfloat)
- type LOD = GLfloat
- textureObjectLODBias :: ParameterizedTextureTarget t => t -> StateVar LOD
- maxTextureLODBias :: GettableStateVar LOD
- textureLODRange :: ParameterizedTextureTarget t => t -> StateVar (LOD, LOD)
- textureMaxAnisotropy :: ParameterizedTextureTarget t => t -> StateVar GLfloat
- maxTextureMaxAnisotropy :: GettableStateVar GLfloat
- textureLevelRange :: ParameterizedTextureTarget t => t -> StateVar (Level, Level)
- generateMipmap :: ParameterizedTextureTarget t => t -> StateVar Capability
- depthTextureMode :: ParameterizedTextureTarget t => t -> StateVar PixelInternalFormat
- textureCompareMode :: ParameterizedTextureTarget t => t -> StateVar (Maybe ComparisonFunction)
- textureCompareFailValue :: ParameterizedTextureTarget t => t -> StateVar GLclampf
- data TextureCompareOperator
  - = LequalR
  - | GequalR
- textureCompareOperator :: ParameterizedTextureTarget t => t -> StateVar (Maybe TextureCompareOperator)

# Documentation

data TextureFilter Source #

Constructors

Nearest |
Linear' |

#### Instances

Instances details

Show TextureFilter Source # |
Instance details Defined in Graphics.Rendering.OpenGL.GL.Texturing.Filter Methods showsPrec :: Int -> TextureFilter -> ShowS Source # show :: TextureFilter -> String Source # showList :: [TextureFilter] -> ShowS Source #
Eq TextureFilter Source # |
Instance details Defined in Graphics.Rendering.OpenGL.GL.Texturing.Filter Methods (==) :: TextureFilter -> TextureFilter -> Bool Source # (/=) :: TextureFilter -> TextureFilter -> Bool Source #
Ord TextureFilter Source # |

Instance details

Defined in Graphics.Rendering.OpenGL.GL.Texturing.Filter

Methods

compare :: TextureFilter -> TextureFilter -> Ordering Source #

(<) :: TextureFilter -> TextureFilter -> Bool Source #

(<=) :: TextureFilter -> TextureFilter -> Bool Source #

(>) :: TextureFilter -> TextureFilter -> Bool Source #

(>=) :: TextureFilter -> TextureFilter -> Bool Source #

max :: TextureFilter -> TextureFilter -> TextureFilter Source #

min :: TextureFilter -> TextureFilter -> TextureFilter Source #

type MinificationFilter = (TextureFilter, Maybe TextureFilter) Source #

type MagnificationFilter = TextureFilter Source #

textureFilter :: ParameterizedTextureTarget t => t -> StateVar (MinificationFilter, MagnificationFilter) Source #

data Repetition Source #

Constructors

Repeated |
Mirrored |

#### Instances

Instances details

Show Repetition Source # |
Instance details Defined in Graphics.Rendering.OpenGL.GL.Texturing.Parameters Methods showsPrec :: Int -> Repetition -> ShowS Source # show :: Repetition -> String Source # showList :: [Repetition] -> ShowS Source #
Eq Repetition Source # |
Instance details Defined in Graphics.Rendering.OpenGL.GL.Texturing.Parameters Methods (==) :: Repetition -> Repetition -> Bool Source # (/=) :: Repetition -> Repetition -> Bool Source #
Ord Repetition Source # |

Instance details

Defined in Graphics.Rendering.OpenGL.GL.Texturing.Parameters

Methods

compare :: Repetition -> Repetition -> Ordering Source #

(<) :: Repetition -> Repetition -> Bool Source #

(<=) :: Repetition -> Repetition -> Bool Source #

(>) :: Repetition -> Repetition -> Bool Source #

(>=) :: Repetition -> Repetition -> Bool Source #

max :: Repetition -> Repetition -> Repetition Source #

min :: Repetition -> Repetition -> Repetition Source #

data Clamping Source #

Constructors

Clamp |
Repeat |
ClampToEdge |
ClampToBorder |

#### Instances

Instances details

Show Clamping Source # |
Instance details Defined in Graphics.Rendering.OpenGL.GL.Texturing.Parameters Methods showsPrec :: Int -> Clamping -> ShowS Source # show :: Clamping -> String Source # showList :: [Clamping] -> ShowS Source #
Eq Clamping Source # |
Instance details Defined in Graphics.Rendering.OpenGL.GL.Texturing.Parameters Methods (==) :: Clamping -> Clamping -> Bool Source # (/=) :: Clamping -> Clamping -> Bool Source #
Ord Clamping Source # |

Instance details

Defined in Graphics.Rendering.OpenGL.GL.Texturing.Parameters

Methods

compare :: Clamping -> Clamping -> Ordering Source #

(<) :: Clamping -> Clamping -> Bool Source #

(<=) :: Clamping -> Clamping -> Bool Source #

(>) :: Clamping -> Clamping -> Bool Source #

(>=) :: Clamping -> Clamping -> Bool Source #

max :: Clamping -> Clamping -> Clamping Source #

min :: Clamping -> Clamping -> Clamping Source #

textureWrapMode :: ParameterizedTextureTarget t => t -> TextureCoordName -> StateVar (Repetition, Clamping) Source #

textureBorderColor :: ParameterizedTextureTarget t => t -> StateVar (Color4 GLfloat) Source #

type LOD = GLfloat Source #

textureObjectLODBias :: ParameterizedTextureTarget t => t -> StateVar LOD Source #

maxTextureLODBias :: GettableStateVar LOD Source #

textureLODRange :: ParameterizedTextureTarget t => t -> StateVar (LOD, LOD) Source #

textureMaxAnisotropy :: ParameterizedTextureTarget t => t -> StateVar GLfloat Source #

maxTextureMaxAnisotropy :: GettableStateVar GLfloat Source #

textureLevelRange :: ParameterizedTextureTarget t => t -> StateVar (Level, Level) Source #

generateMipmap :: ParameterizedTextureTarget t => t -> StateVar Capability Source #

Note: OpenGL 3.1 deprecated this texture parameter, use `generateMipmap'` instead.

depthTextureMode :: ParameterizedTextureTarget t => t -> StateVar PixelInternalFormat Source #

textureCompareMode :: ParameterizedTextureTarget t => t -> StateVar (Maybe ComparisonFunction) Source #

textureCompareFailValue :: ParameterizedTextureTarget t => t -> StateVar GLclampf Source #

data TextureCompareOperator Source #

Constructors

LequalR |
GequalR |

#### Instances

Instances details

Show TextureCompareOperator Source # |
Instance details Defined in Graphics.Rendering.OpenGL.GL.Texturing.Parameters Methods showsPrec :: Int -> TextureCompareOperator -> ShowS Source # show :: TextureCompareOperator -> String Source # showList :: [TextureCompareOperator] -> ShowS Source #
Eq TextureCompareOperator Source # |
Instance details Defined in Graphics.Rendering.OpenGL.GL.Texturing.Parameters Methods (==) :: TextureCompareOperator -> TextureCompareOperator -> Bool Source # (/=) :: TextureCompareOperator -> TextureCompareOperator -> Bool Source #
Ord TextureCompareOperator Source # |

Instance details

Defined in Graphics.Rendering.OpenGL.GL.Texturing.Parameters

Methods

compare :: TextureCompareOperator -> TextureCompareOperator -> Ordering Source #

(<) :: TextureCompareOperator -> TextureCompareOperator -> Bool Source #

(<=) :: TextureCompareOperator -> TextureCompareOperator -> Bool Source #

(>) :: TextureCompareOperator -> TextureCompareOperator -> Bool Source #

(>=) :: TextureCompareOperator -> TextureCompareOperator -> Bool Source #

max :: TextureCompareOperator -> TextureCompareOperator -> TextureCompareOperator Source #

min :: TextureCompareOperator -> TextureCompareOperator -> TextureCompareOperator Source #

textureCompareOperator :: ParameterizedTextureTarget t => t -> StateVar (Maybe TextureCompareOperator) Source #